-- todo: clean this up in a object.
RPT_NILTABLE = {};
RPT_NILFUNCTION = function() end
RPT_Shiftkey = false;

-- Register the RPT_Raidframes;
RPT_Raidframes = {};

--
RPT_Healing = true;
RPT_Debuff  = true;
RPT_DPS = false;


RPT_RF_Timer = 0;
RPT_RF_Raid = {}; -- hierin staat wie op welke plek zit!
RPT_RF_RaidPeopleMax = 40;
RPT_RF_RaidGroupMax = 8;
RPT_RF_FrameInfo = {};
RPT_RF_Active = true;
RPT_InGroup = false;
RPT_InRaid = false;
RPT_RF_Update = false;

RPT_Buffs = {};
RPT_BuffCount = 0;
RPT_Debuffs = {};
RPT_Debuffs2 = {};
RPT_DebuffCount = 0;

-- range checker:
RPT_RangeFunc  = false;
RPT_RangeSpell = false;
RPT_10Range = false;

-- Class colors:
RPT_ClassC = {};

RPT_ClassC["DEATHKNIGHT"] 	= {r= 0.77, g = 0.12, b = 0.23};
RPT_ClassC["DRUID"] 			= {r= 1,00,	g = 0.49, b = 0.04};
RPT_ClassC["HUNTER"] 		= {r= 0.67, g = 0.83, b = 0.45};
RPT_ClassC["MAGE"]			= {r= 0.41, g = 0.80, b = 0.94};
RPT_ClassC["PALADIN"] 		= {r= 0.96, g = 0.55, b = 0.73};
RPT_ClassC["PRIEST"]			= {r= 1.00, g = 1.00, b = 1.00};
RPT_ClassC["ROGUE"]			= {r= 1.00, g = 0.96, b = 0.41};
RPT_ClassC["SHAMAN"]			= {r= 0.14, g = 0.35, b = 1.00};
RPT_ClassC["WARLOCK"]		= {r= 0.58, g = 0.51, b = 0.79};
RPT_ClassC["WARRIOR"]		= {r= 0.78, g = 0.61, b = 0.43};

-- Jobcolors
RPT_JobC = {};
RPT_JobC[0] = {r = 0.3, g = 0.3, b = 0.3 };
RPT_JobC[1] = {r = 0.70, g = 0.13, b = 0.00 }; -- melee dps
RPT_JobC[2] = {r = 0.70, g = 0.00, b = 1.00 }; -- range dps
RPT_JobC[3] = {r = 0.00, g = 0.76, b = 1.00 }; -- OT
RPT_JobC[4] = {r = 0.00, g = 0.40, b = 0.85 }; -- MT
RPT_JobC[5] = {r = 0.00, g = 0.70, b = 0.20 }; -- Healer
RPT_JobC[6] = {r = 0.80, g = 0.50, b = 0.20 }; -- Mounted

RPT_RF_T_Jobnr = {};
RPT_RF_T_Jobnr["melee"] = 1;
RPT_RF_T_Jobnr["caster"] = 2;
RPT_RF_T_Jobnr["tank"] = 3;
RPT_RF_T_Jobnr["healer"] = 5;

-- Readycheck

RPT_readycheck = false;
RPT_readycheck_cd = 0;
RPT_readycheck_pl = 0;

-- CD checker:
local RPT_RF_CD_In = false;
local RPT_RF_CD_Ready = true;
RPT_RF_CD_Offset = 0.1;
RPT_RF_CD_Active = true;

-- Aura Table:
RPT_RF_T_Buff_Inf = {};
RPT_RF_T_TMP_INF = {};

for i = 1, 8 do
	RPT_RF_T_TMP_INF[i] = {}
	RPT_RF_T_Buff_Inf[i] 			= {};
	RPT_RF_T_Buff_Inf[i].info 		= nil;
	RPT_RF_T_Buff_Inf[i].lvl 		= 0;
	RPT_RF_T_Buff_Inf[i].duration 	= 0;
	RPT_RF_T_Buff_Inf[i].timer 		= 0;
	RPT_RF_T_Buff_Inf[i].stack 		= 0;
end

-- aura flash checker.
RPT_RF_T_FlashOn = false;

-- Saved Vars:
-- todo move this.
RPT_RF_CharSettings = {	hide = false,
						layout = 1 };

-- other vars
local RPTRF_HealthcheckCD = 0;
RPT_RF_DISPEL_Magic = false;
RPT_RF_DISPEL_Curse = false;
RPT_RF_DISPEL_Poison = false;
RPT_RF_DISPEL_Disease = false;

-- mark2
function RPT_RF_SetBarColor(frame)
	local r = frame.hbright * frame.hred;
	local g = frame.hbright * frame.hgreen;
	local b = frame.hbright * frame.hblue;
	frame.HP:SetStatusBarColor(r,g,b);
end

function RPT_RoleChange(event,GUID, unit, role, prev)
	local nr = RPT_RF_GetPlayer(unit);
	
	--print(unit.." changes to: "..role);
	
	if nr then
		info = RPT_RF_FrameInfo[nr];
		
		-- only change color when in vehicle
		if not info.vehicle then
			info.job = RPT_RF_T_Jobnr[role];
			local frame = getglobal("RPT_RF_Player"..nr);
			local c = RPT_JobC[info.job];
			frame.Job:SetTexture(c.r,c.g,c.b);
		end
	end
end

local TalentLib;
function RPT_RF_InitTracker()
	
	-- load defaults:
	RPT_RF_ScanDebuffs = RPT_RF_ScanKindDebuffs;
	
 	-- krijg de players class:
 	local class1;
 	local class2;
 	class1, class2 = UnitClass("player");
 	local SpellRange = true;
 	
 	
 	-- set the Class preferences
 	if(class2 == "DRUID") then

 		RPT_RF_AddBuff(1,1,33763); -- Livebloom
	 	RPT_RF_AddBuff(2,1,774); -- Rejuvenation
	 	RPT_RF_AddBuff(4,1,48438); -- Wild Growth
	 	RPT_RF_AddBuff(3,1,8936); -- Regrowth
	 	
	 	RPT_RF_AddDebuff(5,1,"Poison", "Interface\\Icons\\Spell_Nature_NullifyPoison_02");
	 	RPT_RF_AddDebuff(6,1,"Curse",  "Interface\\Icons\\Spell_Holy_RemoveCurse");
 		
		RPT_RF_DISPEL_Curse = true;
		RPT_RF_DISPEL_Poison = true;
 		
 		RPT_RangeSpell = GetSpellInfo(5185);
 		
 	elseif class2 == "PRIEST" then
	 	
	 	RPT_RF_AddBuff(1,1,139); -- Renew
	 	RPT_RF_AddBuff(2,1,17); -- Power Word: Shield
	 	RPT_RF_AddBuff(3,1,33076); -- Prayer of Mending
	 	RPT_RF_AddBuff(4,1,47788); -- Guardian Spirit
	 	
	 	RPT_RF_AddDebuff(5,1,"Disease", "Interface\\Icons\\Spell_Nature_RemoveDisease");
	 	RPT_RF_AddDebuff(6,1,"Magic", "Interface\\Icons\\Spell_Nature_AbolishMagic");
	 	
	 	RPT_RF_DISPEL_Magic = true;
		RPT_RF_DISPEL_Disease = true;
	 	
	 	RPT_RangeSpell = GetSpellInfo(2050);
	 	
	 elseif class2 == "PALADIN" then
		
		RPT_RF_AddBuff(1,1,53563); -- Beacon of Light
	 	RPT_RF_AddBuff(2,1,53601); -- Sacred Shield
	 	RPT_RF_AddBuff(3,1,19750); -- Flash of Light
	 	
	 	
	 	RPT_RF_AddDebuff(4,1,"Magic", "Interface\\Icons\\Spell_Nature_AbolishMagic");
	 	RPT_RF_AddDebuff(6,1,"Disease", "Interface\\Icons\\Spell_Nature_RemoveDisease");
	 	RPT_RF_AddDebuff(5,1,"Poison", "Interface\\Icons\\Spell_Nature_NullifyPoison_02");
	 	
	 	RPT_RF_DISPEL_Magic = true;
		RPT_RF_DISPEL_Disease = true;
		RPT_RF_DISPEL_Poison = true;
	 	
	 	RPT_RangeSpell = GetSpellInfo(635);

	 elseif class2 == "SHAMAN" then
	 	
	 	RPT_RF_AddBuff(1,1,974); -- Earth Shield
	 	RPT_RF_AddBuff(2,1,61295); -- Riptide
	 	RPT_RF_AddBuff(3,1,51945); -- Earthliving
	 	
	 	
	 	RPT_RF_AddDebuff(4,1,"Curse",  "Interface\\Icons\\Spell_Holy_RemoveCurse");
	 	RPT_RF_AddDebuff(6,1,"Disease", "Interface\\Icons\\Spell_Nature_RemoveDisease");
	 	RPT_RF_AddDebuff(5,1,"Poison", "Interface\\Icons\\Spell_Nature_NullifyPoison_02");
	 	
	 	RPT_RF_DISPEL_Curse = true;
		RPT_RF_DISPEL_Disease = true;
		RPT_RF_DISPEL_Poison = true;
		
	 	
	 	RPT_RangeSpell = GetSpellInfo(331);

	else
		-- Dps en tank classes:
		RPT_RangeFunc = UnitInRange;
		
		for i = 1, 40 do
			local frame = getglobal("RPT_RF_Player"..i);
			
			frame.B[6].Texture:SetTexture("Interface\\Icons\\Spell_Frost_Stun");
			frame.B[5].Texture:SetTexture("Interface\\Icons\\Spell_Frost_Stun");
			
			if class2 == "MAGE" then
				RPT_RF_DISPEL_Curse = true;
				RPT_RF_AddDebuff(5,1,"Curse",  "Interface\\Icons\\Spell_Holy_RemoveCurse");
			end
		end
		
		
		
		SpellRange = false;
		RPT_Debuff = false;
		
		RPT_RF_SetDpsLayout();
 	end
 	
 	-- set SpellRangefunction
 	if SpellRange then
 		RPT_RangeFunc = RPT_Range_Function1;
 	end
 	
 	for i = 1, 40 do
		local frame = getglobal("RPT_RF_Player"..i);
		
		RegisterUnitWatch(frame);
		
		frame.Agro:Hide();
		frame.B[1]:SetAlpha(0.2);
		frame.B[2]:SetAlpha(0.2);
		frame.B[3]:SetAlpha(0.2);
		frame.B[4]:SetAlpha(0.2);
		frame.B[5]:SetAlpha(0.2);
		frame.B[6]:SetAlpha(0.2);
	end
 	
end

function RPT_Range_Function1(unit)
	if IsSpellInRange(RPT_RangeSpell, unit) == 1 then
 		return true;
 	else
 		return false;
 	end 
end

function RPT_RF_load(frame)
	
	SLASH_RPT_DRUIDHOTS1 = "/rptrf";
	SlashCmdList["RPT_DRUIDHOTS"] = RPT_RF_SlashCommand;
	SLASH_RPT_TEST1 = "/rptt";
	SlashCmdList["RPT_TEST"] = RPT_T_Slash;
	
	-- load libs:
	-- init talents
	TalentLib = LibStub("LibGroupTalents-1.0")
	TalentLib.RegisterCallback(RPT_Raidframes, "LibGroupTalents_RoleChange", RPT_RoleChange);
	
	-- test het aanzetten van cooldowns:
	local time = GetTime();
	for i = 1, 40 do
		local frame = getglobal("RPT_RF_Player"..i);
		frame.hbright = 1;
		frame.hred = 1;
		frame.hblue = 1;
		frame.hgreen = 1;
		
		frame.B[1].Cd:SetCooldown(time,0);
		frame.B[2].Cd:SetCooldown(time,0);
		frame.B[3].Cd:SetCooldown(time,0);
		frame.B[4].Cd:SetCooldown(time,0);
		frame.B[5].Cd:SetCooldown(time,0);
		frame.B[6].Cd:SetCooldown(time,0);
	end
	
	RPT_RF_InitTracker();
	RPT_RF_ui_init();
	RPT_RF_init();
	RPT_RF_setDefault();
	RPT_RF_Init_DBM();
	
end

function RPT_RF_ui_init()
	RPT_RF_Group2Name_Name:SetText("Group 2");
	RPT_RF_Group3Name_Name:SetText("Group 3");
	RPT_RF_Group4Name_Name:SetText("Group 4");
	RPT_RF_Group5Name_Name:SetText("Group 5");
	RPT_RF_Group6Name_Name:SetText("Group 6");
	RPT_RF_Group7Name_Name:SetText("Group 7");
	RPT_RF_Group8Name_Name:SetText("Group 8");
end

function RPT_RF_init()
	
	-- init the player information data
	for i = 1, 40 do
		RPT_RF_FrameInfo[i] = {	active  		= false,
								player  		= "",
								vehicle 		= false,
								vUnit			= "vehicle",
								frame			= getglobal("RPT_RF_Player"..i);
								debuffs			= {}, --stackcounter debuffs.
								auraName		= {"", "", "", "", "", ""}, -- last texture used.
								range   		= false,
								showHealth		= true,
								dead    		= false,
								agro    		= 0,
								online  		= true,
								job     		= 0,
								flash   		= false, -- quick accesable boolean.
								flash_agro   	= false,
								flash_debuff	= false,
								flash_r 		= 0,
								flash_b 		= 0 };
	end

	-- Reset de UI 
	RPT_RF_ResetUItargets();
end

function RPT_RF_SetParty()
	
	local leader = false;
	local countMax = 2;
	
	-- check or you are leader
	if not UnitIsPartyLeader("player") then
		countMax = countMax + 1;
	end
	
	-- scan de party
	for i=1, 4 do
		local unit = "party"..i;
		if UnitExists(unit) then
			if UnitIsPartyLeader(unit) then
				RPT_RF_SetTargetFrame(unit,"partypet"..i,1,i);
				leader = true;
			else
				RPT_RF_SetTargetFrame(unit,"partypet"..i,countMax,i);
				countMax = countMax + 1;
			end
		end
	end
	
	-- add last frames
	for i = countMax, 5 do
		RPT_SetDummyTargetFrame("party"..(i-1), i, (i-1));
	end
	
	-- list party leader first
	
	if leader then
		RPT_RF_SetTargetFrame("player","vehicle",2,0);
	else
		-- you are first!
		RPT_RF_SetTargetFrame("player","vehicle",1,0);
	end
end

-- verplaats functie en haal table weg;
RPT_RF_T_groups = {};
RPT_RF_T_groups[1] = {};
RPT_RF_T_groups[2] = {};
RPT_RF_T_groups[3] = {};
RPT_RF_T_groups[4] = {};
RPT_RF_T_groups[5] = {};
RPT_RF_T_groups[6] = {};
RPT_RF_T_groups[7] = {};
RPT_RF_T_groups[8] = {};
RPT_RF_T_groupsC = {};

function RPT_RF_SetRaid()
	
	RPT_RF_T_groupsC[1] = 1;
	RPT_RF_T_groupsC[2] = 1;
	RPT_RF_T_groupsC[3] = 1;
	RPT_RF_T_groupsC[4] = 1;
	RPT_RF_T_groupsC[5] = 1;
	RPT_RF_T_groupsC[6] = 1;
	RPT_RF_T_groupsC[7] = 1;
	RPT_RF_T_groupsC[8] = 1;
	
	-- count the players.
	
	-- scan the raid
	for i=1, 40 do
		local unit = "raid"..i;
		if UnitExists(unit) then

			
			-- krijg info:
			local name;
			local rank;
			local groupNr;
			name, rank, groupNr = GetRaidRosterInfo(i);
			
			--print"Gevonden Unit:"..unit.." Group"..groupNr);
			
			-- set Unit in group:
			if groupNr <= RPT_RF_RaidGroupMax then
				local group = RPT_RF_T_groups[groupNr];
				local nr = RPT_RF_T_groupsC[groupNr];
				group[nr] = i;
				RPT_RF_T_groupsC[groupNr] = RPT_RF_T_groupsC[groupNr] + 1;
			end
		end
	end
	
	local max = GetNumRaidMembers() + 1;
	
	for i = 1, RPT_RF_RaidGroupMax do
		--print("loop"..i)
		local group = RPT_RF_T_groups[i];
		
		for y=1, RPT_RF_T_groupsC[i] - 1 do
			local nr = ((i - 1) * 5) + y;
			local unitP = "raid"..group[y];
			
			if UnitIsUnit(unitP,"player") then
				RPT_RF_SetTargetFrame(unitP,"vehicle",nr,group[y]);
			else
				RPT_RF_SetTargetFrame(unitP,"raidpet"..group[y],nr,group[y]);
			end
		end
		
		-- nu de rest
		for y = RPT_RF_T_groupsC[i], 5 do
			local nr = ((i-1)*5) + y;
			RPT_SetDummyTargetFrame("raid"..max, nr, max);
			max = max + 1;
		end
		
		-- check of er iemand in de group zit:
		if ( 1 < RPT_RF_T_groupsC[i]) then
			local frame = getglobal("RPT_RF_Group"..i.."Name");
			frame:Show();
		end
	end
	
	-- disable remaining spots:
	for i = RPT_RF_RaidGroupMax+1, 8 do
		for y = 1, 5 do
			local nr = ((i - 1) * 5) + y;
			frame = getglobal("RPT_RF_Player"..nr);
			frame:SetAttribute("unit", nil);
			frame.Button:SetAttribute("unit", nil);
		end
	end
	
end

function RPT_RF_ResetUItargets()
	HidePartyFrame();
	-- set alles op leeg!
	for i = 1 , 40 do
		-- delete de attribute
		getglobal("RPT_RF_Player"..i):SetAttribute("unit",nil);
		
		RPT_RF_FrameInfo[i].active = false;
	end
	
	-- zorg ervoor dat verwijzingen kloppen:
	for k,v in pairs(RPT_RF_Raid) do
		RPT_RF_Raid[k] = false;
	end
	-- close the groups:
	RPT_RF_Group2Name:Hide();
	RPT_RF_Group3Name:Hide();
	RPT_RF_Group4Name:Hide();
	RPT_RF_Group5Name:Hide();
	RPT_RF_Group6Name:Hide();
	RPT_RF_Group7Name:Hide();
	RPT_RF_Group8Name:Hide();
	
end

function RPT_SetDummyTargetFrame(unit, nr, id)
	local frame = getglobal("RPT_RF_Player"..nr);
	local info = RPT_RF_FrameInfo[nr];
	
	info.active = false;
	
	frame:SetAttribute("unit", unit);
			 
	-- set dropdown menu
	frame.Menu.unit = unit;
	frame.Button.id = id;
 
	-- set buff
	frame.Button:SetAttribute("unit", unit);
 	frame.Button.unit = unit;
 	
 	info.player = unit;
 	info.vUnit = unitpet;
end

function RPT_RF_SetTargetFrame(unit,unitpet, plaats, id, incombat)
	
	local uid = UnitGUID(unit);
	
	-- Bug fix
	if not uid then
		return RPT_SetDummyTargetFrame(unit,plaats,id);
	end
	
	if unit then
		-- set some locals
		local frame = getglobal("RPT_RF_Player"..plaats);
		local info = RPT_RF_FrameInfo[plaats];
		
		
		 if incombat == nil then
			 frame:SetAttribute("unit", unit);
			 
			 -- set dropdown menu
			 frame.Menu.unit = unit;
			 frame.Button.id = id;
			 
			 -- set buff
			 frame.Button:SetAttribute("unit", unit);
		 	 frame.Button.unit = unit;
		 	 
		 	 info.player = unit;
		 	 info.vUnit = unitpet;
		 else
		 	-- check or this unit can be restored to correct info
		 	unit = info.player;
			
			if not UnitExists(unit) then
				info.active = false;
				return;
			end
			
			-- try activating the group name 
			local gNr = string.format("%.0f", ( (plaats - 1) / 5) + 1 );
			local gName = getglobal("RPT_RF_Group"..gNr.."Name");
			gName:Show();
			
			-- repair the vehicle info
			 if UnitIsUnit(unit,"player") then
			 	info.vUnit = "vehicle"; 
			 else
			 	if RPT_InGroup then
			 		info.vUnit = "partypet"..(frame.Button.id);
			 	else
			 		info.vUnit = "raidpet"..(frame.Button.id);
			 	end
			 end
			 unitpet = info.vUnit;
		 end
		
		-- get Id's
		local pName2 = UnitName(unit);	
		
		-- set the unit referance.
		 RPT_RF_Raid[uid] = plaats;
		 	
		 -- set class color
		 local class1, class2 = UnitClass(unit);
		 local color = RPT_ClassC[class2];
		 
		 if color then 
		 	frame.Name:SetText(pName2);
		 	frame.Name:SetTextColor(color.r, color.g, color.b);
		 	
		 	if	RPT_RF_ActiveSettings.hp_barC == 2 then
		 		frame.hred   = color.r;
				frame.hblue  = color.b;
				frame.hgreen = color.g;
				RPT_RF_SetBarColor(frame);
			end
		 end
		 
		 -- activate the frame 
		 info.active = true;
		 
		 -- set Mp color:
		 RPT_RF_SetUnitManaBarColor(unit,frame.MP);
		 frame.MP:SetMinMaxValues(0,UnitPowerMax(unit));
		 frame.MP:SetValue(UnitPower(unit));
		
		 -- force a health update.
		 info.dead = true;
		 RPT_RF_updateHealth(unit);
		 
		 -- reset the range:
		 RPT_RF_playerOutRange(frame,info);
		 
		 -- set player role:
		 local job = TalentLib:GetUnitRole(unit);
		 if job then
			info.job = RPT_RF_T_Jobnr[job];		
		 else
			info.job = 0;
		 end
 
		 -- check or player is online:
		 if UnitIsConnected(unit) then
		 	info.online = true;
		 else
			info.online = false;
			frame.HP:SetValue(0);
			frame:SetAlpha(0.5);
			frame.Dead:SetText("Offline");
		 end
		
		 if UnitInVehicle(unit) then
		 	RPT_RF_SetVehicle(unit,UnitHasVehicleUI(unit));
		 elseif info.vehicle then
		 	RPT_RF_LeaveVehicle(unit);
		 end
	 end
end

function RPT_RF_SlashCommand(msg)
	msg = string.lower(msg);
	
	if msg == "hide" then
		RPT_RF_Toggle();
	elseif msg == "showall" then
		RPT_RF_ShowAll();
	elseif msg == "resetpos" then
		RPT_RP_ResetPos();
	elseif msg == "dpsframes" then
		RPT_RF_SetDpsLayout();
	elseif msg == "healframes" then
		RPT_RF_SetHealLayout();
	elseif msg == "resetg" then
		RPT_RF_PMC();
	else 
		print("command list:");
		print("- hide : hides/shows RPT_Raidframes");
		print("- resetpos : attempts to reset the position of the raidframes");
		print("- dpsframes : shows the dps layout");
		print("- healframes : shows the heal layout");
	end
end

function RPT_RF_Toggle(show)

	if RPT_RF_Main:IsShown() and not show then
		RPT_RF_Main:Hide();
		RPT_RF_ActiveSettings.hide = true;
		RPT_OP4_RB1_enable:SetChecked(false);
		RPT_RF_Active = false;
		if RPT_InGroup then
			ShowPartyFrame();
		end 
	else
		RPT_RF_Main:Show();
		RPT_RF_ActiveSettings.hide = false;
		RPT_RF_Active = true;
		RPT_OP4_RB1_enable:SetChecked(true);
		RPT_RF_PMC()
	end
end

function RPT_RF_event(frame,event, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9)
  if(RPT_RF_Active) then	
	if event == "UNIT_HEALTH" then
		return RPT_RF_updateHealth(arg1);
	elseif event == "PARTY_MEMBERS_CHANGED" then
		return RPT_RF_PMC();
	elseif event == "UNIT_DISPLAYPOWER" then
		return RPT_RF_SetPower(arg1);
	elseif event == "PLAYER_REGEN_ENABLED" then
		--print"Out of Combat!");
		if RPT_RF_Update then
			RPT_RF_Update = false;
			RPT_RF_PMC();
			RPT_RF_ActivateSettings(RPT_RF_ActiveSettings);
		end
		return nil;
	elseif event == "READY_CHECK" then
		if ( RPT_InGroup and IsPartyLeader() ) or IsRaidOfficer() or IsRaidLeader() then
			RPT_RF_InitReadycheck(arg1);
		end
		return nil;
	elseif event == "READY_CHECK_CONFIRM" then
		if RPT_readycheck then
			RPT_RF_AnswerReadycheck(arg1,arg2);
		end
		return nil;
	elseif evnet == "READY_CHECK_FINISHED" then
		if RPT_readycheck then
			return RPT_RF_FinishedReadycheck();
		end
	elseif event == "UNIT_ENTERED_VEHICLE" then
		return RPT_RF_SetVehicle(arg1,arg2);
	elseif event == "UNIT_PET" then
		return HidePartyFrame();
	elseif event == "UNIT_EXITED_VEHICLE" then
		return RPT_RF_LeaveVehicle(arg1);
	elseif event == "PLAYER_ENTERING_WORLD" then
		return RPT_RF_CheckInstance();
	end
  end
	
  -- event that must be scanned even out of the run
  if event == "ADDON_LOADED" then
	return RPT_RF_DBM_Link(arg1);
  elseif event == "ACTIVE_TALENT_GROUP_CHANGED" then
  	RPT_RF_SetSettings();
  	RPT_RF_CheckC2H();
  elseif event == "PLAYER_LOGIN" then
	return RPT_RF_InitSettings();
  end
end

function RPT_RF_InitSettings()
	
	RPT_RF_CheckC2H();
	RPT_RF_InitConfig();


	-- init layout
	if RPT_RF_CharSettings.layout == 2 then
		RPT_RF_SetDpsLayout();
	end
	
	-- init visable
	if RPT_RF_CharSettings.hide then
		RPT_RF_Main:Hide();
		RPT_RF_Active = false;
	else
		RPT_RF_PMC();
	end
	
	
end

function RPT_RF_PMC()
  if InCombatLockdown() then
  	 HidePartyFrame();
     RPT_RF_Update = true;
  	 RPT_RepairNames();
  else
	 RPT_RF_ResetUItargets();
	 RPT_InGroup = false;
 	 RPT_InRaid = false;
	
	 -- test party method:
	 if UnitInRaid("player") then
		RPT_InRaid = true;
	 	
	 	-- in raid!
	 	RPT_RF_SetRaid();
	 elseif UnitInParty("player") then
		RPT_InGroup = true;
		
		-- in party!
		RPT_RF_SetParty()
	 else
		RPT_RF_SetTargetFrame("player","vehicle", 1);
	 end
  end
  
  -- set the corect job colors.
  RPT_RF_SetJobcolors();
end

-- temp testing functions:
local oldfuncUnitHealth = UnitHealth;
RPTT_RF_Health = 0;
local function RPT_RF_FakeHealth()
	UnitHealth = function(unit)
			if UnitIsUnit(unit,"player") then
				return RPTT_RF_Health * UnitHealthMax(unit);
			else
				return oldfuncUnitHealth(unit);
			end
		end
end

local function RPT_RF_UpdateFakeHealth(a)
	RPTT_RF_Health = a;
	RPT_RF_updateHealth("player")
end

-- Health update and its functions
-- mark1

function RPT_RF_UpdateHealthText1(frame,h,mh)
	-- percentage health.
	frame.Dead:SetText( string.format("%.0f",100 * (h / mh)).."%");
end

function RPT_RF_UpdateHealthText2(frame,h,mh)
	-- health lost in k's
	local ch = mh - h;
	
	if mh < 10000000 then
		txt = string.format("%.1f", ch * 0.001).." K";
	else
		txt = string.format("%.1f", ch * 0.000001).." M";
	end
	
	frame.Dead:SetText( "-"..txt );
end

function RPT_RF_UpdateHealthText3(frame,h,mh)
	-- health in k's
	local txt;
	
	if h < 10000000 then
		txt = string.format("%.1f", h * 0.001).." K";
	else
		txt = string.format("%.1f", h * 0.000001).." M";
	end
	
	frame.Dead:SetText( txt );
end

RPT_RF_UpdateHealthText = RPT_RF_UpdateHealthText1;
function RPT_RF_updateHealth(unit)

	-- check of the target is in the targets.
  	local targetNr = RPT_RF_GetPlayer(unit);
  	
  	if targetNr then
  		local frameT = getglobal("RPT_RF_Player"..targetNr);
		local info = RPT_RF_FrameInfo[targetNr];
		
		local health = UnitHealth(unit);
		local mhealth = UnitHealthMax(unit);
		
		frameT.HP:SetMinMaxValues(0,mhealth);
		frameT.HP:SetValue(health);
		
		if info.showHealth then
			RPT_RF_UpdateHealthText(frameT,health,mhealth)
		end
		
		-- set color shifting.
		if RPT_RF_ActiveSettings.hp_barC == 3 then
			local ph = health/mhealth;
			if ph > 0.85 then
				if ph == 1 then
					frameT.hred   = 0;
					frameT.hgreen = 1;
					frameT.hblue = 0.8;
				else
					frameT.hred   = 0;
					frameT.hgreen = 1;
					frameT.hblue = 0;
				end
			elseif ph < 0.10 then
				frameT.hred   = 1;
				frameT.hgreen = 0;
				frameT.hblue = 0;
			else
				frameT.hblue = 0;
				if ph > 0.5 then
					frameT.hgreen = 1;
					--frameT.hred = 1 - ((ph - 0.5) / 0.7 * 2);
					local tmp = (ph - 0.5 ) / 0.7 * 2;
					tmp = tmp * tmp;
					frameT.hred = 1 - (tmp * tmp);
				else
					frameT.hgreen = (ph - 0.15) / 0.7 * 2;
					frameT.hred = 1;
				end
			end
			
			RPT_RF_SetBarColor(frameT);
		end
		
	 	RPT_RF_SetAndCheckDead(unit,frameT,info);
	end
end

function RPT_RF_setDefault()
	--message("Default set!");
	--RPT_RF_Frame1_HP:SetMinMaxValues(0,UnitHealthMax("player"));
	--RPT_RF_Frame1_HP:setValue(UnitHealth("player"));
	--RPT_RF_Frame1_MP:SetMinMaxValues(0,UnitPowerMax("player"));
	--RPT_RF_Frame1_MP:setValue(UnitPower("player"));
end

function RPT_RF_OnUpdate(frame,elapsed)
 
  if (RPT_RF_Active) then
  
   RPT_RF_FlashTest(elapsed);
	RPT_RF_Timer = RPT_RF_Timer + elapsed;
	if(RPT_RF_Timer > 0.3)
	then
		RPT_RF_Timer = RPT_RF_Timer - 0.3;
		
		if RPT_RF_Timer > 0.3 then
			RPT_RF_Timer = 0;
		end
		
		-- shiftkey test:
		if not RPT_DPS then
			local spressed = IsShiftKeyDown();
			
			if not (spressed == RPT_Shiftkey) then
				RPT_Shiftkey = spressed;
				if spressed then
					for i = 1, 40 do
						local frame = getglobal("RPT_RF_Player"..i);
						frame.DPS:Show();
					end
				else
					for i = 1, 40 do
						local frame = getglobal("RPT_RF_Player"..i);
						frame.DPS:Hide();
					end
				end
			end
		end
		-- readycheck CD
		if RPT_readycheck_cd ~= 0 then
			RPT_readycheck_cd = RPT_readycheck_cd - 1;
			if RPT_readycheck_cd == 0 then
				RPT_RF_SetJobcolors();
			end
		end
		-- bewerk de aura's
		for i = 1, RPT_RF_RaidPeopleMax do
			if RPT_RF_FrameInfo[i].active then
				RPT_RF_update_info(i);
			end
		end
		
		-- healthcheck cooldown
		RPTRF_HealthcheckCD = RPTRF_HealthcheckCD + 1;
		
		if RPTRF_HealthcheckCD == 20 then
			RPTRF_HealthcheckCD = 0;
			for i = 1, 40 do
				local info = RPT_RF_FrameInfo[i];
				
				-- was buggy when people dc'ed.
				if info.online then
					local unit = info.player;
					
					-- also check or vehicle info is still correct, it seems events aren't fired sometimes in patch 3.3.0.
					-- this is a temp fix, want to check or the event for other players changed or it is a bug ingame.
					if UnitInVehicle(unit) then
						if not info.vehicle then
							RPT_RF_SetVehicle(unit,UnitHasVehicleUI(unit));
						end
					elseif info.vehicle then
						RPT_RF_LeaveVehicle(unit);
					end
				
					RPT_RF_updateHealth(unit);
				end
			end
		end
	end
  end
end

RPT_RF_T_tmpAura = {};
RPT_RF_ScanDebuffs = nil;
function RPT_RF_update_info(nr)


	local buffnr = 1;
	local playerInf = RPT_RF_FrameInfo[nr];
	local target;
	
	if playerInf.vehicle then
		target = playerInf.vUnit;
	else
		target = playerInf.player;
	end
	
	local frame = getglobal("RPT_RF_Player"..nr);
	
	-- check or unit exists.
	if UnitExists(target) then 
		-- check or he is online:
		if UnitIsConnected(target) then
			if not playerInf.online then
				playerInf.online = true;
				RPT_RF_updateHealth(target);
				RPT_RF_playerInRange(frame,playerInf);
			end
		else
			if playerInf.online then
				playerInf.online = false;
				frame.HP:SetValue(0);
				frame:SetAlpha(0.5);
				frame.Dead:SetText("Offline");
			end
		end
	
		-- Update the power:
		frame.MP:SetMinMaxValues(0,UnitPowerMax(target));
		frame.MP:SetValue(UnitPower(target));
		
		-- check healing range
		if RPT_RangeFunc(target) then
			if not playerInf.range then
				RPT_RF_playerInRange(frame,playerInf);
			end
		else
			if playerInf.range then
				RPT_RF_playerOutRange(frame,playerInf);
			end
		end
		
		-- check threat status:
		local agro = UnitThreatSituation(target);
		
		if agro ~= playerInf.agro then
			RPT_RF_SetAgro(frame,agro,playerInf);
		end
		
		-- resets the aura Table:
		for i = 1, 6 do
			RPT_RF_T_Buff_Inf[i].lvl = 0;
		end
		
		-- scan buffs and debuffs, curently only buffs.
		while(RPT_Healing)
		do
			local name, rank, texture, stack, kind, duration, timer, caster = UnitBuff(target,buffnr,1);
			buffnr = buffnr + 1;
			
			if not name then
				break;
			end
			-- only register your buffs
			
			if caster and UnitIsUnit("player",caster) then
				
				-- check or the buff is whatched:
				local bInfo = RPT_Buffs[name];
				
				if bInfo then
					local nr = bInfo.nr;
					
					-- check info priority
					if 	RPT_RF_T_Buff_Inf[nr].lvl < bInfo.lvl then
						-- store the info
						RPT_RF_T_Buff_Inf[nr].lvl 		= bInfo.lvl;
						RPT_RF_T_Buff_Inf[nr].info 		= bInfo;
						RPT_RF_T_Buff_Inf[nr].timer 	= timer;
						RPT_RF_T_Buff_Inf[nr].duration	= duration;
						RPT_RF_T_Buff_Inf[nr].stack		= stack;
					end 
				end
			end
		end
	
		-- Zoek naar Debuffs:
		RPT_RF_ScanDebuffs(target,frame,playerInf);
		
		-- clear deactivated (de)buffs.
		for i = 1, 6 do
			local Finfo = RPT_RF_T_Buff_Inf[i];
			
			if Finfo.lvl > 0 then
				-- set the frame:
				frame.B[i]:SetAlpha(1);
				
				if Finfo.duration and Finfo.duration > 0 then
					frame.B[i].Cd:Show();
					frame.B[i].Cd:SetCooldown( Finfo.timer - Finfo.duration , Finfo.duration);
				else
					--frame.B[i].Cd:SetCooldown(GetTime(),0);
					frame.B[i].Cd:Hide();
				end
				
				if Finfo.info.texture ~= playerInf.auraName[i] then
					playerInf.auraName[i] = Finfo.info.texture;
					frame.B[i].Texture:SetTexture(Finfo.info.texture);
				end
				
				if Finfo.stack > 1 then
					frame.B[i].Stack:SetText(Finfo.stack);
				else
					frame.B[i].Stack:SetText("");
				end
			else
				-- deactivates the frames.
				frame.B[i].Stack:SetText("");
				frame.B[i].Cd:SetCooldown(GetTime(),0);
				frame.B[i]:SetAlpha(0.2);
			end
		end
	end
end

function RPT_RF_GetPlayer(unit)
	
	if unit == "vehicle" then
		unit = "player";
		return RPT_RF_Raid[UnitGUID(unit) or 0];
	else
		local sStart, sEnd = string.find(unit,"pet"); 
		if sStart then
			
			if unit == "pet" then
				unit = "player";
			elseif RPT_InRaid then
				unit = "raid"..(string.sub(unit,sEnd+1));
			else
				unit = "party"..(string.sub(unit,sEnd+1));
			end
			
			local infoNr = RPT_RF_Raid[UnitGUID(unit) or 0];
			
			if infoNr and RPT_RF_FrameInfo[infoNr].vehicle then
				return infoNr;
			else
				return false;
			end
			
		else
			local infoNr = RPT_RF_Raid[UnitGUID(unit) or 0];
			if infoNr then
				if RPT_RF_FrameInfo[infoNr].vehicle then
					return false;
				else
					return infoNr;
				end
			end
		end
	end
end


function RPT_RF_SetAndCheckDead(unit,frame,info)
	if UnitIsDeadOrGhost(unit) then
		frame.HP:SetValue(0);
		frame:SetBackdropColor(0,0,0,0.9);
		frame.Dead:SetText("Dead");
		frame.Dead:Show();
		info.dead = true;
	elseif info.dead then
		info.dead = false;
		RPT_RF_playerOutRange(frame,info);
		--frame.Dead:Hide();
	end
	
end

-- broken need a fix for the range10.
function RPT_RF_playerInRange(frame,playerInf)
	frame:SetAlpha(1);
	frame.hbright = 1;
	RPT_RF_SetBarColor(frame);
	playerInf.range = true;
end

function RPT_RF_playerOutRange(frame,playerInf)

	-- get the color:
	frame:SetAlpha(0.5);
	
	frame.hbright = 0.5;
	RPT_RF_SetBarColor(frame);
	
	playerInf.range = false;
end

function RPT_RF_SetAgro(frame,agro,info)
	info.agro = agro;
	if not agro then
		agro = 0;
	end
	
		
	if agro == 0 and not info.flash_debuff then
		frame.Agro:Hide();
	else
		frame.Agro:Show();
	end
	
	local r,g,b = GetThreatStatusColor(agro);
	
	frame.Agro:SetTexture(r,g,b,1);
	
	if agro == 3 then
		info.flash = true;
		info.flash_agro = true;
		info.flash_r = 1;
	else
		info.flash_agro = false;
		
		if not info.flash_debuff then
			--print("flash deactivated!");
			info.flash = false;
		end
		
		info.flash_r = 0;
	end
end

rpt_rf_flash_Timer = 1;
rpt_rf_flash_reverse = false;

function RPT_RF_FlashTest(elasped)
	
	if rpt_rf_flash_reverse then
		rpt_rf_flash_Timer = rpt_rf_flash_Timer - elasped;
		if rpt_rf_flash_Timer < 0 then
			rpt_rf_flash_Timer = 0 - rpt_rf_flash_Timer;
			rpt_rf_flash_reverse = false;
		end
	else
		rpt_rf_flash_Timer = rpt_rf_flash_Timer + elasped;
		if rpt_rf_flash_Timer > 1 then
			rpt_rf_flash_Timer = 2 - rpt_rf_flash_Timer;
			rpt_rf_flash_reverse = true;
		end
	end
		
	for i = 1, 26 do 
		local info = RPT_RF_FrameInfo[i];
		if info and info.flash then
			local frame = getglobal("RPT_RF_Player"..i);
			frame.Agro:SetTexture(info.flash_r,rpt_rf_flash_Timer,info.flash_b,1);
		end
	end
end

function RPT_RF_SetPower(unit)
	-- test of Unit in het berijk zit:
	local infoNr = RPT_RF_GetPlayer(unit);
	
	if infoNr then
		local frame = getglobal("RPT_RF_Player"..infoNr);
		
		RPT_RF_SetUnitManaBarColor(unit,frame.MP);
	end
end

function RPT_RF_frameSize(size)
	
	local sizeY = 43 + (size * 16);
	print("size: "..sizeY);
	
	for nr = 1 , 40 do
		local frame = getglobal("RPT_RF_Player"..nr);
		frame:SetHeight(sizeY);
		frame.Button:SetHeight(sizeY);
	end
end

function RPT_RF_InitReadycheck(unit)
	--print("unit ="..unit);
	RPT_readycheck = true;
	RPT_readycheck_cd = 110;
	
	-- set all colors on not decided:
	RPT_readycheck_pl = 0;
	for nr = 1 , 40 do
		local info = RPT_RF_FrameInfo[nr];
		if info.active then
			RPT_readycheck_pl = RPT_readycheck_pl + 1;
		end
		
		local frame = getglobal("RPT_RF_Player"..nr);
		frame.Job:SetTexture(0.5,0.5,0);
	end
	
	RPT_readycheck_pl = RPT_readycheck_pl - 1;
	local targetNr = RPT_RF_Raid[UnitGUID(unit) or 0];
	if targetNr then
		local frame = getglobal("RPT_RF_Player"..targetNr);
		frame.Job:SetTexture(0,1,0);	
	end
end

function RPT_RF_AnswerReadycheck(unit)
	-- hidden update? blizzard changed the layout?
	-- they did, now it only returns the unit and added a function that returns the status in string.
	
	local targetNr = RPT_RF_GetPlayer(unit);
	
	if targetNr then
		local frame = getglobal("RPT_RF_Player"..targetNr);
		
		local answer = GetReadyCheckStatus(unit);
		
		
		if answer == "ready" then
			frame.Job:SetTexture(0,1,0);
			RPT_readycheck_pl = RPT_readycheck_pl -1;
		elseif answer == "notready" then
			frame.Job:SetTexture(1,0,0);
			RPT_readycheck_pl = RPT_readycheck_pl -1;
		end	
	end
	
	if RPT_readycheck_pl == 0 then
		RPT_readycheck_cd = 45;
	end
end

function RPT_RF_FinishedReadycheck()
	--print("finished");
	RPT_readycheck_cd = 45;
end

function RPT_RF_SetJobcolors()
	for nr = 1 , 40 do
		local info = RPT_RF_FrameInfo[nr];
		if info.active then
			-- here comes the job!
			local c = RPT_JobC[info.job];
			local frame = getglobal("RPT_RF_Player"..nr);
			frame.Job:SetTexture(c.r,c.g,c.b);
		end
	end
end

function RPT_RF_ShowAll()
	-- set alles op leeg!
	for i = 1 , 40 do
		getglobal("RPT_RF_Player"..i):Show();
	end
	
	-- close the groups:
	RPT_RF_Group2:Show();
	RPT_RF_Group3:Show();
	RPT_RF_Group4:Show();
	RPT_RF_Group5:Show();
	RPT_RF_Group6:Show();
	RPT_RF_Group7:Show();
	RPT_RF_Group8:Show();
	
end

function RPT_RP_ResetPos()
	RPT_RF_Group1Name:SetPoint("TOP", "RPT_RF_Group1", "TOP", 0, 0);
	RPT_RF_Group2Name:SetPoint("TOP", "RPT_RF_Group2", "TOP", 0, 0);
	RPT_RF_Group3Name:SetPoint("TOP", "RPT_RF_Group3", "TOP", 0, 0);
	RPT_RF_Group4Name:SetPoint("TOP", "RPT_RF_Group4", "TOP", 0, 0);
	RPT_RF_Group5Name:SetPoint("TOP", "RPT_RF_Group5", "TOP", 0, 0);
	RPT_RF_Group6Name:SetPoint("TOP", "RPT_RF_Group6", "TOP", 0, 0);
	RPT_RF_Group7Name:SetPoint("TOP", "RPT_RF_Group7", "TOP", 0, 0);
	RPT_RF_Group8Name:SetPoint("TOP", "RPT_RF_Group8", "TOP", 0, 0);
end

RPT_RP_ReadySet_l = ConfirmReadyCheck;
ConfirmReadyCheck = function(ready)
	if RPT_readycheck then
		RPT_readycheck_pl = RPT_readycheck_pl -1
		
		if RPT_readycheck_pl == 0 then
			RPT_readycheck_cd = 45;
		end
		
		local targetNr = RPT_RF_GetPlayer("player");
		if targetNr then
			local frame = getglobal("RPT_RF_Player"..targetNr);
			if ready then
				frame.Job:SetTexture(0,1,0);
			else
				frame.Job:SetTexture(1,0,0);
			end	
		end
	end
	
	RPT_RP_ReadySet_l(ready);
end

function RPT_RF_Menu_Initialize(frame)
	if frame.unit then
		local frame = UIDROPDOWNMENU_OPEN_MENU or frame;
		
		if UnitIsUnit(frame.unit,"player") then
			UnitPopup_ShowMenu(frame, "SELF", frame.unit);
		elseif RPT_InRaid == true then
			local nr = GetRaidTargetIndex(frame.unit);
			UnitPopup_ShowMenu(frame, "RAID", nr);
		else
			UnitPopup_ShowMenu(frame, "PARTY", frame.unit);
		end
	end
end

function rptdhts_TargetMenu(frame)
	if RPT_InRaid then
		HideDropDownMenu(1);
		FriendsDropDown.name = frame.name;
		FriendsDropDown.id = frame.id;
		FriendsDropDown.unit = frame.unit;
		FriendsDropDown.initialize = RaidFrameDropDown_Initialize;
		FriendsDropDown.displayMode = "MENU";
		ToggleDropDownMenu(1, nil, FriendsDropDown, frame, 93, 35);
	else
		ToggleDropDownMenu(1, nil, frame.Parent.Menu, frame, 93, 35);
	end
end

function RPT_RF_SetVehicle(unit,arg2)
	HidePartyFrame();
	local guid = UnitGUID(unit) or 0;
	local targetNr = RPT_RF_Raid[guid];
	
	if targetNr then
		local frame = getglobal("RPT_RF_Player"..targetNr);
		local info  = RPT_RF_FrameInfo[targetNr];
		
		-- only redirect health if the health is actually trackable.
		if arg2 then 
			info.vehicle = true;
			RPT_RF_updateHealth(info.vUnit);
			
			RPT_RF_SetJobcolors();
			if UnitIsUnit(unit,"player") then
				RPT_RangeFunc = UnitInRange;
			end
			
			info.job = 6;
			RPT_RF_SetJobcolors();
		end
	end
end


function RPT_RF_LeaveVehicle(unit)

	-- Is this changed in 3.3.0?
	HidePartyFrame();
	local guid = UnitGUID(unit) or 0;
	local targetNr = RPT_RF_Raid[guid];
	
	if targetNr then
		local frame = getglobal("RPT_RF_Player"..targetNr);
		local info  = RPT_RF_FrameInfo[targetNr];
		
		info.vehicle = false;
		
		RPT_RF_updateHealth(unit);
		
		if RPT_RangeSpell and UnitIsUnit(unit,"player") then
			RPT_RangeFunc = RPT_Range_Function1;	
		end
		
		-- set correct job:
		local job = TalentLib:GetUnitRole(unit);
		if job then
			info.job = RPT_RF_T_Jobnr[job];		
		else
			info.job = 0;
		end

		RPT_RF_SetJobcolors();
	end
end

function RPT_RF_SetDpsLayout()
	RPT_RF_CharSettings.layout = 2;
	RPT_DPS = true;
	RPT_Healing = false;
	
	-- set the unitframes
	for i = 1, 40 do
		local frame = getglobal("RPT_RF_Player"..i);
		
		frame.HP:SetPoint("TOPLEFT" , 10, -2);
		frame.HP:SetHeight(12);
		
		frame.MP:SetPoint("TOPLEFT" , 10, -27);
		frame.MP:SetHeight(7);
		
		frame.DPS:SetPoint("TOPLEFT" , 10, -14);
		frame.DPS:SetWidth(64);
		frame.DPS:SetHeight(13);
		frame.DPS:Show();
		
		frame.Name:SetWidth(64);
		
		-- hide unnececairy healframes
		frame.B[1]:Hide();
		frame.B[2]:Hide();
		frame.B[3]:Hide();
		frame.B[4]:Hide();
	end
	
end

function RPT_RF_SetHealLayout()
	RPT_DPS = false;
	RPT_Healing = true;
	RPT_RF_CharSettings.layout = 1;
	
	-- set the unitframes
	for i = 1, 40 do
		local frame = getglobal("RPT_RF_Player"..i);
		
		frame.HP:SetPoint("TOPLEFT" , 10, -2);
		frame.HP:SetHeight(12);
		
		frame.MP:SetPoint("TOPLEFT" , 10, -14);
		frame.MP:SetHeight(4);
		
		frame.DPS:SetPoint("TOPLEFT" , 10, -18);
		frame.DPS:SetWidth(80);
		frame.DPS:SetHeight(16);
		frame.DPS:Hide();
		
		frame.Name:SetWidth(80);
		
		-- show nececairy healframes
		frame.B[1]:Show();
		frame.B[2]:Show();
		frame.B[3]:Show();
		frame.B[4]:Show();	
	end
end

function RPT_RF_ScanKindDebuffs(unit,frame,playerInf)
		
		
		local buffnr = 1;
		
		-- sets the duration on default:
		
		-- init de buffcount
		for k,v in pairs(RPT_Debuffs) do
			v.stack = 0;
		end
		
		while RPT_Debuff do
			local name, rank, texture, stack, kind, duration, timer, caster = UnitDebuff(unit,buffnr,1);
			buffnr = buffnr + 1;
			
			
			
			if( not name )then
				break;
			end
			if kind then
				-- tell de buffs
				local dInfo = RPT_Debuffs[kind];
				if stack == 0 then
					stack = 1;
				end
				
				--print("stack:"..stack);
				if dInfo then
					-- handle it here:
					dInfo.stack = dInfo.stack + stack;
					--print("stack total:"..dInfo.stack);
				end
			end
		end
		
		-- check or debuff must be activated:
		for k , v in pairs(RPT_Debuffs) do
			--print(k);
			if v.stack > 0 then
				--print("stack found:"..(v.stack));
				local nr = v.nr;
				if RPT_RF_T_Buff_Inf[nr].lvl < v.lvl then
					RPT_RF_T_Buff_Inf[nr].lvl = v.lvl;
					RPT_RF_T_Buff_Inf[nr].stack = v.stack;
					RPT_RF_T_Buff_Inf[nr].info = v;
					RPT_RF_T_Buff_Inf[nr].duration = false;
				end
			end
		end
end

-- to improve: buble the activate/deactivate function up, and hold data who got debuff and who doesn't.
function RPT_RF_ScanSpecialDebuffs(unit,frame,playerInf)
	
	RPT_RF_T_FlashOn = false;
	
	-- set all debuffs on unnoticed:
	for _,v in pairs(RPT_Debuffs2) do
		v.found = true;
	end
	
	-- scan the debuffs:
	local buffnr = 1;
	while true do
		local name, rank, texture, stack, kind, duration, timer, caster = UnitDebuff(unit,buffnr);
		buffnr = buffnr + 1;
		
		if( not name )
		then
			break;
		end
		
		-- check or the debuff is in the list
		local dInfo = RPT_Debuffs2[""..name]
		
		if dInfo then
			dInfo.found = false;
			
			-- mark him found:
			local nr = dInfo.nr
			if dInfo.lvl > RPT_RF_T_Buff_Inf[nr].lvl then
				RPT_RF_T_Buff_Inf[nr].info = dInfo;
				RPT_RF_T_Buff_Inf[nr].lvl = dInfo.lvl;
				RPT_RF_T_Buff_Inf[nr].duration = duration;
				RPT_RF_T_Buff_Inf[nr].timer = timer;
				RPT_RF_T_Buff_Inf[nr].stack = stack;
			end
			
			if dInfo.flash then
				RPT_RF_T_FlashOn = true;
			end
			
			-- format the stack
			stack = stack or 1;
			
			-- check or he needs an activation
			if dInfo.action then
				local dDinfo = playerInf.debuffs[name];
				if dDinfo ~= stack then 
					dInfo.action(unit,dInfo,stack,playerInf);
				end
			end
			
			-- store the stack:
			playerInf.debuffs[name] = stack;
		end
	end
	
	-- check what debuffs need deactivation:
	for k,v in pairs(RPT_Debuffs2) do
		if v.found then
			-- needs deactivation
			playerInf.debuffs[k] = 0;
			if v.deactivate then
				v.deactivate(unit,v,playerInf);
			end
		end
	end
	
	-- handle the flash.
	if RPT_RF_T_FlashOn then
		playerInf.flash = true;
		playerInf.flash_b = 1;
		playerInf.flash_debuff = true;
		frame.Agro:Show();
	elseif playerInf.flash then
		playerInf.flash_b = 0;
		playerInf.flash_debuff = false;
		
		if not playerInf.flash_agro then
			local agro = UnitThreatSituation(unit);
			RPT_RF_SetAgro(frame,agro,playerInf);
			
			playerInf.flash = false;
		end
	end
end

function RPT_RF_CheckC2H()
	
	local talents = GetActiveTalentGroup(false,false);
	
	-- first check or you have C2H already loaded:
	if RPT_C2H_Loaded then
		RPT_C2H_SetButtonSet(talents);
		RPT_C2H_InitOptions();
		collectgarbage();
	else
		-- check or you got C2H data
		if RPT_RF_CharSettings.C2H then
			-- check or you must activate these settings:
			if talents == 1 and RPT_RF_CharSettings.C2H.enable1 then
				if (IsAddOnLoadOnDemand("RPT_C2H")) then
	        		LoadAddOn("RPT_C2H");
	  			end
			elseif talents == 2 and RPT_RF_CharSettings.C2H.enable2 then
				if (IsAddOnLoadOnDemand("RPT_C2H")) then
	        		LoadAddOn("RPT_C2H");
	  			end
			end
		end
	end
end

-- this function repairs the frames when someone leaves the party during battle.
function RPT_RepairNames()
	-- reset all links to Unitframes by playername:
	for k,v in pairs(RPT_RF_Raid) do
		RPT_RF_Raid[k] = false;
	end
	
	-- hide group names:
	for gNr = 1, 8 do
		local gName = getglobal("RPT_RF_Group"..gNr.."Name");
		gName:Hide();
	end
	
	-- repair all links.
	for i=1, RPT_RF_RaidPeopleMax do
		local info = RPT_RF_FrameInfo[i];
		local frame = getglobal("RPT_RF_Player"..i);
		
		RPT_RF_SetTargetFrame(frame:GetAttribute("unit"),nil, i, nil, true);
	end
end

-- new!
function RPT_RF_AddBuff(nr,lvl,sid)
	
	local name, texture;
	name, _ , texture = GetSpellInfo(sid);
	
	RPT_Buffs[name] = {};
	local buff = RPT_Buffs[name];
	
	buff.name = name;
	buff.nr = nr;
	buff.lvl = lvl;
	buff.texture = texture;
	
	if lvl == 1 then
		for i = 1, 40 do
			local frame = getglobal("RPT_RF_Player"..i);
 			frame.B[nr].Texture:SetTexture(texture);
  		end
	end
end

function RPT_RF_AddDebuff(nr,lvl,kind, texture)
	
	RPT_Debuffs[kind] = {};
	local buff = RPT_Debuffs[kind];
	buff.name = kind;
	buff.nr = nr;
	buff.lvl = lvl;
	buff.texture = texture
	
	if lvl == 1 then
		for i = 1, 40 do
			local frame = getglobal("RPT_RF_Player"..i);
 			frame.B[nr].Texture:SetTexture(texture);
  		end
	end
end

function RPT_RF_SetUnitManaBarColor(unit, manaBar)

	-- copied from blizzard code, slightly modded.
	local powerType, powerToken, altR, altG, altB = UnitPowerType(unit);
	local info = PowerBarColor[powerToken];
	if info then
		manaBar:SetStatusBarColor(info.r, info.g, info.b);
	else
		if ( not altR) then
			-- couldn't find a power token entry...default to indexing by power type or just mana if we don't have that either
			info = PowerBarColor[powerType] or PowerBarColor["MANA"];
			manaBar:SetStatusBarColor(info.r, info.g, info.b);
		else
			manaBar:SetStatusBarColor(altR, altG, altB);
		end
	end
end


function RPT_RF_SetMaxRaidGroups(maxG)
	RPT_RF_RaidPeopleMax = maxG * 5;
	RPT_RF_RaidGroupMax = maxG;
	
	-- trigger PMC.
	RPT_RF_PMC();
end

function RPT_RF_CheckInstance()
	if RPT_RF_ActiveSettings.capRaidGroups and IsInInstance() then
		-- fetch the instanceinfo
		local _, _, _, _, maxPlayers = GetInstanceInfo();
		local maxG = floor((maxPlayers-1)/5 + 1);
		--print("setMaxG:"..maxG);
		RPT_RF_SetMaxRaidGroups(maxG);
	else
		RPT_RF_SetMaxRaidGroups(8);
	end
end