
RPT_C2H_Settings = nil;
RPT_C2H_Loaded = true;

RPT_C2H_CurentSettings ={};
RPT_C2H_TempSettings = {};
RPT_C2H_Changed = false;


-- click to heal is an experiment to enable click healing.
function RPT_CH_OnLoad()
	RPT_RF_C2H_CreateDropdown();
	
	-- set the interface button:
	RPT_Eneble_C2H:SetText("RPT_C2H OPTIONS");
	
	if RPT_RF_CharSettings.C2H then
		RPT_C2H_Settings = RPT_RF_CharSettings.C2H;
	else
	
		-- set defaults
		RPT_C2H_Settings = 	{}
		RPT_C2H_Settings.bindings1 = {};
		
		RPT_C2H_Settings.bindings1[1] = {};
		RPT_C2H_Settings.bindings1[2] = {};
		RPT_C2H_Settings.bindings1[3] = {};
		RPT_C2H_Settings.bindings1[4] = {};
		RPT_C2H_Settings.bindings1[5] = {};
		
		RPT_C2H_Settings.bindings2 = {};
		
		RPT_C2H_Settings.bindings2[1] = {};
		RPT_C2H_Settings.bindings2[2] = {};
		RPT_C2H_Settings.bindings2[3] = {};
		RPT_C2H_Settings.bindings2[4] = {};
		RPT_C2H_Settings.bindings2[5] = {};
		
		RPT_C2H_Settings.enable1 = true;
		RPT_C2H_Settings.enable2 = true;
		RPT_C2H_Settings.version = 1;
		RPT_RF_CharSettings.C2H = RPT_C2H_Settings;
		
		
		print("[RPT_C2H] says: For setup plz go to the addon option panel in the menu interface. From there go to RPT_C2H under the RPT Menu.");
	end
	
	for i = 1, 25 do
		local frame = getglobal("RPT_RF_Player"..i);
		local button = frame.Button;
		
		button:RegisterForClicks( "LeftButtonDown","RightButtonDown", "MiddleButtonDown","Button4Down","Button5Down", "Button6Down", "Button7Down", "Button8Down", "Button9Down", "Button10Down", "Button11Down", "Button12Down", "Button13Down", "Button14Down", "Button15Down" );
	end
	
	RPT_RF_FOCUSFRAME:RegisterForClicks( "LeftButtonDown","RightButtonDown", "MiddleButtonDown","Button4Down","Button5Down", "Button6Down", "Button7Down", "Button8Down", "Button9Down", "Button10Down", "Button11Down", "Button12Down", "Button13Down", "Button14Down", "Button15Down" );
	
	RPT_RF_TARGETFRAME:RegisterForClicks( "LeftButtonDown","RightButtonDown", "MiddleButtonDown","Button4Down","Button5Down", "Button6Down", "Button7Down", "Button8Down", "Button9Down", "Button10Down", "Button11Down", "Button12Down", "Button13Down", "Button14Down", "Button15Down" );
	
	local talents = GetActiveTalentGroup(false,false);
	
	RPT_C2H_SetButtonSet(talents);
	RPT_C2H_InitOptions();
end

--- Option Functions:
for i = 0,15 do
	RPT_C2H_TempSettings[i] = {};
	RPT_C2H_TempSettings[i][""] = {}
	RPT_C2H_TempSettings[i]["alt-"] = {}
	RPT_C2H_TempSettings[i]["ctrl-"] = {}
	RPT_C2H_TempSettings[i]["shift-"] = {}
	RPT_C2H_TempSettings[i]["alt-ctrl-"] = {}
	RPT_C2H_TempSettings[i]["alt-shift-"] = {}
	RPT_C2H_TempSettings[i]["ctrl-shift-"] = {}
	RPT_C2H_TempSettings[i]["alt-ctrl-shift-"] = {}
end

function RPT_C2H_Healbutton_OnEnter(frame)
	local hType, hId, extra1 = GetCursorInfo()
	
	if hType == "spell" and not IsPassiveSpell(hId, extra1 ) then
		local name = GetSpellName(hId,extra1);
		frame:SetBackdropBorderColor(0,1,1);
	elseif hType == "macro" then
		frame:SetBackdropBorderColor(0,1,1);
	elseif RPT_C2H_Cursor_Hold == "target" then
		frame:SetBackdropBorderColor(0,1,1);
	elseif RPT_C2H_Cursor_Hold == "focus" then
		frame:SetBackdropBorderColor(0,1,1);
	elseif RPT_C2H_Cursor_Hold == "clear" then
		frame:SetBackdropBorderColor(0,1,1);
	end

end

function RPT_C2H_Healbutton_OnClick(frame)
	local hType, hId, extra1 = GetCursorInfo()
	
	if hType == "spell" and not IsPassiveSpell(hId, extra1 ) then
		local name = GetSpellName(hId,extra1);
		local _ , _, icon = GetSpellInfo(name);
		
		frame.Icon:SetTexture(icon);
		frame.T2:SetText(name);
		frame.data.kind = hType;
		frame.data.action = name;
		frame:SetBackdropColor(0,1,1);
		RPT_C2H_Changed = true;
	elseif hType == "macro" then
		local name, icon = GetMacroInfo(hId);
		frame.Icon:SetTexture(icon);
		frame.T2:SetText(name);
		frame.data.kind = hType;
		frame.data.action = hId;
		frame:SetBackdropColor(1,0,1);
		RPT_C2H_Changed = true;
	elseif RPT_C2H_Cursor_Hold == "target" then
		frame.Icon:SetTexture("Interface\\Icons\\Ability_Hunter_FocusedAim")
		frame.T2:SetText("Action: Target");
		frame.data.kind = "target";
		frame.data.action = "target";
		frame:SetBackdropColor(1,1,0);
		RPT_C2H_Changed = true;
	elseif RPT_C2H_Cursor_Hold == "focus" then
		frame.Icon:SetTexture("Interface\\Icons\\Ability_Warrior_Revenge")
		frame.T2:SetText("Action: SetFocus");
		frame.data.kind = "focus";
		frame.data.action = "focus";
		frame:SetBackdropColor(1,1,0);
		RPT_C2H_Changed = true;
	elseif RPT_C2H_Cursor_Hold == "clear" then
		frame:SetBackdropColor(0.2,0.2,0.2);
		table.wipe(frame.data);
		frame.T2:SetText("Drop an action on this.");
		frame.Icon:SetTexture("Interface\\Icons\\INV_Misc_QuestionMark");
		RPT_C2H_Changed = true;
	end
	
	ClearCursor();
end

RPT_C2H_Cursor_Hold = false;
RPT_C2H_ClearCursor_Old = ClearCursor;
function RPT_C2H_ClearCursor()
	
	SetCursor("POINT_CURSOR");
	
	RPT_C2H_ClearCursor_Old()
	
	RPT_C2H_Cursor_Hold = false;
	
	ClearCursor = RPT_C2H_ClearCursor_Old;
	RPT_C2H_ClearCursor_Old = false;
end


function RPT_C2H_SetPointerHold(info)
	ClearCursor();
	SetCursor("CAST_CURSOR");
	
	RPT_C2H_ClearCursor_Old = ClearCursor;
	ClearCursor = RPT_C2H_ClearCursor;
	
	RPT_C2H_Cursor_Hold = info; 
end

function RPT_C2H_ActivateSettings(settings)

	local pre, info;
	local bNr, mods
	
	-- unlink the buttons previous used, flagging them caused garbage.
	for bNr,mods in pairs(RPT_C2H_CurentSettings) do
		for pre, info in pairs(mods) do
			RPT_C2H_REM_Key(bNr,pre,info.kind);
		end
	end
	
	-- activate or change current settings:
	for bNr,mods in pairs(settings) do
		local oldSets = RPT_C2H_CurentSettings[bNr];
		for pre, info in pairs(mods) do
			if info.kind then
				RPT_C2H_ADD_Key(bNr,pre,info);
			end
		end
	end
	
	collectgarbage();
	-- the linking for next settings must be activated in a other function	
end


function RPT_C2H_SetButtonSet(nr)
	-- nr is the talent used:
	if nr == 1 then
		
		if RPT_C2H_Settings.enable1 then
			RPT_C2H_ActivateSettings(RPT_C2H_Settings.bindings1);
			RPT_C2H_CurentSettings = RPT_C2H_Settings.bindings1;
		else
			RPT_C2H_ActivateSettings(RPT_NILTABLE);
			RPT_C2H_CurentSettings = RPT_NILTABLE;
		end
	elseif nr == 2 then
		
		if RPT_C2H_Settings.enable2 then
			RPT_C2H_ActivateSettings(RPT_C2H_Settings.bindings2);
			RPT_C2H_CurentSettings = RPT_C2H_Settings.bindings2;
		else
			RPT_C2H_ActivateSettings(RPT_NILTABLE);
			RPT_C2H_CurentSettings = RPT_NILTABLE;
		end
	end
	
	-- collect the garbage:
	collectgarbage();
end

function RPT_C2H_ADD_Key(bNr,pre,info)
	if info.kind then
		for i = 1, 25 do
			local frame = getglobal("RPT_RF_Player"..i);
			local button = frame.Button;
			
			button:SetAttribute( pre.."helpbutton"..bNr, "heal"..bNr  );
				button:SetAttribute( pre.."type-heal"..bNr,  info.kind );
				
			if info.kind == "spell" or info.kind == "macro" then
				button:SetAttribute( pre..""..(info.kind).."-heal"..bNr, info.action );
			end
		end
		
		local frame = RPT_RF_FOCUSFRAME;
		local button = frame;
		
		button:SetAttribute( pre.."helpbutton"..bNr, "heal"..bNr  );
			button:SetAttribute( pre.."type-heal"..bNr,  info.kind );
			
		if info.kind == "spell" or info.kind == "macro" then
			button:SetAttribute( pre..""..(info.kind).."-heal"..bNr, info.action );
		end
		
		-- target
		local frame = RPT_RF_TARGETFRAME;
		local button = frame;
		
		button:SetAttribute( pre.."helpbutton"..bNr, "heal"..bNr  );
			button:SetAttribute( pre.."type-heal"..bNr,  info.kind );
			
		if info.kind == "spell" or info.kind == "macro" then
			button:SetAttribute( pre..""..(info.kind).."-heal"..bNr, info.action );
		end
	end
end

function RPT_C2H_REM_Key(bNr,pre, kind)
	for i = 1, 25 do
		local frame = getglobal("RPT_RF_Player"..i);
		local button = frame.Button;
		
		button:SetAttribute( pre.."helpbutton"..bNr, nil );
		button:SetAttribute( pre.."type-heal"..bNr,  nil );
		
		if kind == "spell" then
			button:SetAttribute( pre.."spell-heal"..bNr, nil );
		elseif kind == "macro" then
			button:SetAttribute( pre.."macro-heal"..bNr, nil );
		end
	end
	
	-- remove action from focus frame:
	local frame = RPT_RF_FOCUSFRAME;
	local button = frame;
	
	button:SetAttribute( pre.."helpbutton"..bNr, nil );
	button:SetAttribute( pre.."type-heal"..bNr,  nil );
	
	if kind == "spell" then
		button:SetAttribute( pre.."spell-heal"..bNr, nil );
	elseif kind == "macro" then
		button:SetAttribute( pre.."macro-heal"..bNr, nil );
	end
	
	-- target frame
	local frame = RPT_RF_TARGETFRAME;
	local button = frame;
	
	button:SetAttribute( pre.."helpbutton"..bNr, nil );
	button:SetAttribute( pre.."type-heal"..bNr,  nil );
	
	if kind == "spell" then
		button:SetAttribute( pre.."spell-heal"..bNr, nil );
	elseif kind == "macro" then
		button:SetAttribute( pre.."macro-heal"..bNr, nil );
	end
end
	
function RPT_C2H_ChangeSettingPage(page)
	RPT_C2H_ST_AddInfo2Button(RPT_C2H_HealButton1,"");
	RPT_C2H_ST_AddInfo2Button(RPT_C2H_HealButton2,"shift-");
	RPT_C2H_ST_AddInfo2Button(RPT_C2H_HealButton3,"ctrl-");
	RPT_C2H_ST_AddInfo2Button(RPT_C2H_HealButton4,"alt-");
	RPT_C2H_ST_AddInfo2Button(RPT_C2H_HealButton5,"ctrl-shift-");
	RPT_C2H_ST_AddInfo2Button(RPT_C2H_HealButton6,"alt-ctrl-");
	RPT_C2H_ST_AddInfo2Button(RPT_C2H_HealButton7,"alt-shift-");
	RPT_C2H_ST_AddInfo2Button(RPT_C2H_HealButton8,"alt-ctrl-shift-");
end

RPT_C2H_ST_Button = 1;

function RPT_C2H_ST_AddInfo2Button(frame,mods)
	frame.data = RPT_C2H_TempSettings[RPT_C2H_ST_Button][mods];
	frame.mods = mods
	
	-- get the texture:
	local icon;
	local text;
	
	if not frame.data.kind then
		text = "Drop an action on this.";
		icon = "Interface\\Icons\\INV_Misc_QuestionMark";
		frame:SetBackdropColor(0.2,0.2,0.2);
	elseif frame.data.kind == "spell" then
		
		local name;
		name, _ , icon = GetSpellInfo(frame.data.action);
		if not name then
			name = frame.data.action;
		end
		text = name;
		frame:SetBackdropColor(0,1,1);
	elseif frame.data.kind == "macro" then
		frame:SetBackdropColor(1,0,1);
		local name;
		name, icon = GetMacroInfo(frame.data.action);
		if not name then
			name = frame.data.action;
		end
		text = name;
		frame:SetBackdropColor(1,0,1);
	elseif frame.data.kind == "target" then
		text = "Action: Target";
		icon = "Interface\\Icons\\Ability_Hunter_FocusedAim";
		frame:SetBackdropColor(1,1,0);
	elseif frame.data.kind == "focus" then
		text = "Action: SetFocus";
		icon = "Interface\\Icons\\Ability_Warrior_Revenge";
		frame:SetBackdropColor(1,1,0);
	end
	
	frame.Icon:SetTexture(icon);
	--frame.T1:SetText("Modifiers: "..mods);
	frame.T2:SetText(text);
end

function RPT_C2H_InitChangesList()
	
	-- fetch the current bindings:
	local talents = GetActiveTalentGroup(false,false);
	local curent = nil;
	
	if talents == 1 then
		curent = RPT_C2H_Settings.bindings1;
	elseif talents == 2 then
		curent = RPT_C2H_Settings.bindings2;
	end
	
	-- contruct the new list
	for i = 0,5 do
		local tmpInf = curent[i];
		
		if not tmpInf then
			tmpInf = RPT_NILTABLE;
		end
		
		-- wipes old data:
		table.wipe( RPT_C2H_TempSettings[i][""] );
		table.wipe( RPT_C2H_TempSettings[i]["alt-"] );
		table.wipe( RPT_C2H_TempSettings[i]["ctrl-"] );
		table.wipe( RPT_C2H_TempSettings[i]["shift-"] );
		table.wipe( RPT_C2H_TempSettings[i]["alt-ctrl-"] );
		table.wipe( RPT_C2H_TempSettings[i]["alt-shift-"] );
		table.wipe( RPT_C2H_TempSettings[i]["ctrl-shift-"] );
		table.wipe( RPT_C2H_TempSettings[i]["alt-ctrl-shift-"] );
		
		-- copy data, should work without garbage.
		if tmpInf[""] 				 then 	RPT_C2H_TempSettings[i][""].action				  = tmpInf[""].action; 
											RPT_C2H_TempSettings[i][""] .kind 				  = tmpInf[""].kind; 				  end
		if tmpInf["alt-"] 			 then 	RPT_C2H_TempSettings[i]["alt-"].action			  = tmpInf["alt-"].action; 
											RPT_C2H_TempSettings[i]["alt-"].kind			  = tmpInf["alt-"].kind; 			  end
		if tmpInf["ctrl-"] 			 then 	RPT_C2H_TempSettings[i]["ctrl-"].kind 			  = tmpInf["ctrl-"].kind;
											RPT_C2H_TempSettings[i]["ctrl-"].action 		  = tmpInf["ctrl-"].action; 		  end
		if tmpInf["shift-"] 		 then 	RPT_C2H_TempSettings[i]["shift-"].kind 			  = tmpInf["shift-"].kind; 
											RPT_C2H_TempSettings[i]["shift-"].action		  = tmpInf["shift-"].action; 		  end
		if tmpInf["alt-ctrl-"] 		 then 	RPT_C2H_TempSettings[i]["alt-ctrl-"].kind  		  = tmpInf["alt-ctrl-"].kind;
											RPT_C2H_TempSettings[i]["alt-ctrl-"].action 	  = tmpInf["alt-ctrl-"].action;	 	  end
		if tmpInf["alt-shift-"]		 then 	RPT_C2H_TempSettings[i]["alt-shift-"].kind 		  = tmpInf["alt-shift-"].kind;
											RPT_C2H_TempSettings[i]["alt-shift-"].action	  = tmpInf["alt-shift-"].action; 	  end
		if tmpInf["ctrl-shift-"]	 then 	RPT_C2H_TempSettings[i]["ctrl-shift-"].kind 	  = tmpInf["ctrl-shift-"].kind;
											RPT_C2H_TempSettings[i]["ctrl-shift-"].action 	  = tmpInf["ctrl-shift-"].action; 	  end
		if tmpInf["alt-ctrl-shift-"] then 	RPT_C2H_TempSettings[i]["alt-ctrl-shift-"].kind	  = tmpInf["alt-ctrl-shift-"].kind; 
											RPT_C2H_TempSettings[i]["alt-ctrl-shift-"].action = tmpInf["alt-ctrl-shift-"].action; end
	end
	
end

function RPT_CH_Accept_Changes()
	
	local talents = GetActiveTalentGroup(false,false);
	
	-- set the enable bools
	local bool1 = RPT_C3H_CheckButton_Spec1:GetChecked();
	if bool1 then bool1 = true; else bool1 = false; end
	
	if talents == 1 then
		RPT_C2H_Settings.enable1 = bool1;
	elseif talents == 2 then
		RPT_C2H_Settings.enable2 = bool1;
	end
	
	if RPT_C2H_CheckChanges() then
		RPT_C2H_SaveChanges();
	end
end

function RPT_CH_Cancel_Changes()
	if RPT_C2H_CheckChanges() then
		print("[RPT_C2H] says: Option Panel closed without saving changes.")
		RPT_C2H_InitOptions();
	end
end

function RPT_C2H_CheckChanges()
	if RPT_C2H_Changed then
		return true;
	else
		local bool1 = RPT_C3H_CheckButton_Spec1:GetChecked();
		local bool2 = RPT_C3H_CheckButton_Spec2:GetChecked();
		if bool1 then bool1 = true; else bool1 = false; end
		if bool2 then bool2 = true; else bool2 = false; end
		
		if bool1 ~= RPT_C2H_Settings.enable1 then
			return true;
		elseif bool2 ~= RPT_C2H_Settings.enable2 then
			return true; 
		end
	end
	
	return false;
end

function RPT_C2H_InitOptions()
	RPT_C2H_Changed = false;
	-- todo
	RPT_C2H_InitChangesList();
	
	
	RPT_C2H_ST_Button = 1;
	RPT_C2H_ChangeSettingPage();
	
	-- set the text
	RPT_C2H_HealButton1.T1:SetText("       |     |");
	RPT_C2H_HealButton2.T1:SetText("shift|     |");
	RPT_C2H_HealButton3.T1:SetText("       |ctrl|");
	RPT_C2H_HealButton4.T1:SetText("       |     |alt");
	RPT_C2H_HealButton5.T1:SetText("shift|ctrl|");
	RPT_C2H_HealButton6.T1:SetText("       |ctrl|alt");
	RPT_C2H_HealButton7.T1:SetText("shift|     |alt");
	RPT_C2H_HealButton8.T1:SetText("shift|ctrl|alt");
	
	local talents = GetActiveTalentGroup(false,false);
	local bool = false;
	
	if talents == 1 then
		bool = RPT_C2H_Settings.enable1;
	elseif talents == 2 then
		bool = RPT_C2H_Settings.enable2;
	end
	 
	RPT_C3H_CheckButton_Spec1:SetChecked(bool)
end

function RPT_C2H_SaveChanges()
	-- fetch the spec:
	-- fetch the current bindings:
	local talents = GetActiveTalentGroup(false,false);
	local curent = nil;
	
	if talents == 1 then
		curent = RPT_C2H_Settings.bindings1;
	elseif talents == 2 then
		curent = RPT_C2H_Settings.bindings2;
	end
	
	-- activate the settings is its neccesairy
	if talents == 1 then
		if RPT_C2H_Settings.enable1 then 
			RPT_C2H_ActivateSettings(RPT_C2H_TempSettings);
		else
			RPT_C2H_ActivateSettings(RPT_NILTABLE);
		end
	elseif talents == 2 then
		if RPT_C2H_Settings.enable2 then 
			RPT_C2H_ActivateSettings(RPT_C2H_TempSettings);
		else
			RPT_C2H_ActivateSettings(RPT_NILTABLE);
		end
	end
	
	-- now the settings are activated its save to destroy the old settings and
	-- save the new ones.
	for k1,v1 in pairs(curent) do
		for k2, v2 in pairs(v1) do
			table.wipe(v2);
			v2 = nil;
		end
		table.wipe(v1);
		v1 = nil;
	end
	
	
	if talents == 1 then
		curent = RPT_C2H_Settings.bindings1;
	elseif talents == 2 then
		curent = RPT_C2H_Settings.bindings2;
	end
	
	-- now it is copied its time to save the new settings to the spec
	for k1,v1 in pairs(RPT_C2H_TempSettings) do
		for k2,v2 in pairs(v1) do
			if v2.kind then
				curent[k1][k2] = {}
				curent[k1][k2].action = v2.action;
				curent[k1][k2].kind	  = v2.kind;
			end
		end
	end
	
	-- now the new link is correct we can link the curent settings to this one
	if talents == 1 then
		if bool1 then 
			RPT_C2H_CurentSettings = RPT_C2H_Settings.bindings1;
		else
			RPT_C2H_CurentSettings = RPT_NILTABLE;
		end
	elseif talents == 2 then
		if bool2 then 
			RPT_C2H_CurentSettings = RPT_C2H_Settings.bindings2;
		else
			RPT_C2H_CurentSettings = RPT_NILTABLE;
		end
	end
	
	-- collect my garbage:
	collectgarbage();
end

function RPT_C2H_ActivateButtonPage(frame,button)
	-- check or button is known.
	print(string.match(button, "%d+"));
end

-- cooldown handler:

local RPT_C2H_CD_Cursor = nil;
local RPT_RF_CD_In = false;
local RPT_C2H_EventFrame = CreateFrame("Frame",nil,UIParent);


function RPT_C2H_Frame_OnEnter(...)
	UnitFrame_OnEnter(...);
	RPT_RF_CD_In = true;
end

function RPT_C2H_Frame_OnLeave(...)
	UnitFrame_OnLeave(...);
	RPT_RF_CD_In = false;
	RPT_C2H_CD_Cursor = nil;
end

function RPT_C2H_CheckCD()
	local sT, d = GetItemCooldown(6948); -- Hearthstone, who doesn't have one!
	
	local eT = sT + d - RPT_RF_CD_Offset - GetTime();
	if eT > 0 then
		RPT_C2H_CD_Cursor = "CAST_ERROR_CURSOR";
	else
		RPT_C2H_CD_Cursor = "CAST_CURSOR";
	end
	
	if RPT_RF_CD_In then
		SetCursor(RPT_C2H_CD_Cursor);
	end
end

function RPT_C2H_Enable_CD()
	RPT_C2H_EventFrame:SetScript("OnUpdate", RPT_C2H_CheckCD);
	
	for i = 1, 25 do 
		local frame = getglobal("RPT_RF_Player"..i).Button;
		frame:SetScript("OnEnter", RPT_C2H_Frame_OnEnter);
		frame:SetScript("OnLeave", RPT_C2H_Frame_OnLeave);
	end
end

function RPT_C2H_Disable_CD()
	RPT_C2H_EventFrame:SetScript("OnUpdate", nil);
	
	RPT_C2H_CD_Cursor = nil;
	RPT_RF_CD_In = false;
	
	for i = 1, 25 do 
		local frame = getglobal("RPT_RF_Player"..i).Button;
		frame:SetScript("OnEnter", UnitFrame_OnEnter);
		frame:SetScript("OnLeave", UnitFrame_OnLeave);
	end
end

-- Create dropdown:
function RPT_RF_C2H_CreateDropdown()
	if not RPT_RF_C2H_DropDown1 then
	   CreateFrame("Frame", "RPT_RF_C2H_DropDown1", RPT_Optionpanel_C2H, "UIDropDownMenuTemplate")
	end
	
	RPT_RF_C2H_DropDown1:ClearAllPoints()
	RPT_RF_C2H_DropDown1:SetPoint("TOPLEFT", RPT_Optionpanel_C2H, 225, -150)
	RPT_RF_C2H_DropDown1:Show()
	
	local items = {
	   "left mousebutton",
	   "right mousebutton",
	   "Middle Button",
	   "mousebutton 4",
	   "mousebutton 5",
	   "mousebutton 6",
	   "mousebutton 7",
	   "mousebutton 8",
	   "mousebutton 9",
	   "mousebutton 10",
	   "mousebutton 11",
	   "mousebutton 12",
	   "mousebutton 13",
	   "mousebutton 14",
	   "mousebutton 15"
	}
	
	local function OnDropDownclick1(self)
		RPT_C2H_ST_Button = self:GetID();
	   UIDropDownMenu_SetSelectedID(RPT_RF_C2H_DropDown1, RPT_C2H_ST_Button);
	   RPT_C2H_ChangeSettingPage();
	end
	
	local function initialize(self, level)
	   local info = UIDropDownMenu_CreateInfo()
	   for k,v in pairs(items) do
	      info = UIDropDownMenu_CreateInfo()
	      info.text = v
	      info.value = v
	      info.func = OnDropDownclick1
	      UIDropDownMenu_AddButton(info, level)
	   end
	end
	
	
	UIDropDownMenu_Initialize(RPT_RF_C2H_DropDown1, initialize)
	UIDropDownMenu_SetWidth(RPT_RF_C2H_DropDown1, 120);
	UIDropDownMenu_SetButtonWidth(RPT_RF_C2H_DropDown1, 144)
	UIDropDownMenu_SetSelectedID(RPT_RF_C2H_DropDown1, 1)
	UIDropDownMenu_JustifyText(RPT_RF_C2H_DropDown1, "LEFT")
end
