-- Detection of bosses is done by:

-- *********************************************************
-- **                  Deadly Boss Mods                   **
-- **            http://www.deadlybossmods.com            **
-- *********************************************************

-- This addon links the combatstart and combatend functions of DBM to determen which boss is been fighten.
-- Thanks to the detection system by 'Deadly Boss Mods', this addon can activate the debuffwatchers that are of intrest during the fight.
-- Unfortunatly my addon can only show 2 debuffs at the time so some debuffs share posistions with a priority system.

-- DBM links
function RPT_RF_DBM_Link_Ulduar()

	RPT_RF_Hook_DBM( "Ignis"		, RPT_RF_DMB_Ignius			);
	RPT_RF_Hook_DBM( "Razorscale"	, RPT_RF_DMB_Razorscale		);
	RPT_RF_Hook_DBM( "XT002"		, RPT_RF_DMB_XT002			);
	RPT_RF_Hook_DBM( "Kologarn" 	, RPT_RF_DMB_Kologarn 		);
	RPT_RF_Hook_DBM( "Thorim" 		, RPT_RF_DMB_Thorim 		);
	RPT_RF_Hook_DBM( "Mimiron" 		, RPT_RF_DMB_Mimiron		);
	RPT_RF_Hook_DBM( "GeneralVezax" , RPT_RF_DMB_GeneralVezax	);	
	RPT_RF_Hook_DBM( "YoggSaron" 	, RPT_RF_DMB_YoggSaron		);
	
	
end

function RPT_RF_DMB_Ignius()
	RPT_RF_DBM_Debuff(5,1, 63477, true,false,false,10); -- Slag Pot
	RPT_RF_DBM_Debuff(6,1, 63472, false,false,false,8); -- Flame Jets
end

function RPT_RF_DMB_Razorscale()
	RPT_RF_DBM_Debuff(5,1, 64771, false,false,false,20); -- Fuse Armor
	RPT_RF_DBM_Debuff(6,1, 64023, false,false,false,60); -- Flame Buffet
end

function RPT_RF_DMB_XT002()
	RPT_RF_DBM_Debuff(5,1, 63018, true,false,false,9);	-- Searing Light
	RPT_RF_DBM_Debuff(6,1, 63024, true,false,false,9);	-- Gravity Bomb
end

function RPT_RF_DMB_Kologarn()
	RPT_RF_DBM_Debuff(5,1, 63355, false,false,false,45); -- Crunch Armor
	RPT_RF_DBM_Debuff(6,1, 62056, true,false,false,false); -- Stone Grip
end

function RPT_RF_DMB_Mimiron()
	RPT_RF_DBM_Debuff(5,1, 63666, true,false,false,8); -- Napalm Shell
end

function RPT_RF_DMB_GeneralVezax()
	RPT_RF_DBM_Debuff(5,1, 63276, true,false,false,10); -- Mark of the Faceless
	RPT_RF_DBM_Debuff(6,1, 63322, false,false,false,4); -- Saronite Vapors
end

function RPT_RF_DMB_Thorim()
	RPT_RF_DBM_Debuff(5,1, 62527, true,false,false,4); -- Rune Detonation
end


function RPT_RF_DMB_YoggSaron()
	-- note more debuffs to be listed!
	local nr = 2; 
	
	if RPT_RF_DISPEL_Curse then
		RPT_RF_DBM_Debuff(5,nr, 69969, true,false,false,12); -- Curse of Doom
		nr = nr + 1;
	end
	
	if RPT_RF_DISPEL_Poison then
		RPT_RF_DBM_Debuff(5,nr,64152 , true,false,false,18); -- Draining Poison
		nr = nr + 1;
	end
	
	if RPT_RF_DISPEL_Disease then
		RPT_RF_DBM_Debuff(5,nr,64155 ,true,false,false,24); -- Black Plague
		nr = nr + 1
	end 
	if RPT_RF_DISPEL_Magic then
		RPT_RF_DBM_Debuff(5,nr,64156,true,false,false,20); -- Apathy
		nr = nr + 1;
	end
	
	RPT_RF_DBM_Debuff(5,1, 64125 ,true,false,false,false); -- Squeeze
	
	
	RPT_RF_DBM_Debuff(6,1, 63050 ,false,false,false,false); -- Sanity
	RPT_RF_DBM_Debuff(6,2, 63120 ,false,false,false,60); -- Insane
end
